package run.to.aho.naming;

import org.eclipse.jface.preference.FieldEditor;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

public class NamingPreferencePage extends PreferencePage implements IWorkbenchPreferencePage {

	private FileFieldEditor home;
	
    public NamingPreferencePage() {
        super();
		setPreferenceStore(NamingPlugin.getDefault().getPreferenceStore());
    }

    public NamingPreferencePage(String title) {
        super(title);
    }

    public NamingPreferencePage(String title, ImageDescriptor image) {
        super(title, image);
    }

    protected Control createContents(Composite parent) {

    	final Composite composite = new Composite(parent, SWT.NONE);
    	composite.setLayout(new GridLayout(1, false));

    	Group dictionaryGroup = new Group(composite, SWT.NONE);
    	home = new FileFieldEditor(
    			"dictionaryPath",
    			"t@C",
    			dictionaryGroup);

    	new Label(composite, SWT.NULL); //blank
    	initLayoutAndData(dictionaryGroup, 3);	
    	this.initField(home);

    	Label label = new Label(composite, SWT.NONE);
    	Image image = NamingPlugin.getImageDescriptor("img/yu01.png").createImage();
    	label.setImage(image);

    	return parent;
    }

    public void init(IWorkbench workbench) {
    }

 	private void initField(FieldEditor field) {
		field.setPreferenceStore(getPreferenceStore());
		field.setPage(this);
		field.load();
	}

 	private void initLayoutAndData(Composite aGroup, int numColumns) {
		GridLayout gl = new GridLayout(numColumns, false);
		aGroup.setLayout(gl);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 1;
		gd.widthHint = 400;
		aGroup.setLayoutData(gd);
	}
 	
	public boolean performOk() {
		home.store();
		NamingPlugin.getDefault().savePluginPreferences();

		return true;
	}

}
