package run.to.aho.naming.core;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class DictionaryFile {
	private Dictionary[] dictionary;
	
	//CSVt@Cǂݍ
	public void read(String path) throws Exception {
		File csv = new File(path);
		if (!csv.exists()) {
			throw new FileNotFoundException("t@C܂");
		}
		BufferedReader br = new BufferedReader(new FileReader(csv));
		List<Dictionary> list = new ArrayList<Dictionary>();
		while (br.ready()) {
			String line = br.readLine();
			String st[] = line.split(",");
			//CSṼf[^ɕA_Eꍇ̑Ώ
			if (st.length >= 2) {
				list.add(new Dictionary(st[0], st[1]));
			} else if (st.length == 1) {
				list.add(new Dictionary(st[0], ""));
			}
		}
		br.close();
		this.dictionary = list.toArray(new Dictionary[0]);
	}
	
	//\[g
	public void sort() throws Exception {
		Arrays.sort(this.dictionary);
	}
	
	//_ϖ𕨗ɕϊ
	public String getPysicalName(String logicalName) throws Exception {
		for(Dictionary dic : this.dictionary) {
			logicalName = logicalName.replaceAll(dic.getLogicalName(), dic.getPysicalName());
		}
		return logicalName;
	}

	public Dictionary[] getDictionary() {
		return dictionary;
	}

	public void setDictionary(Dictionary[] dictionary) {
		this.dictionary = dictionary;
	}
}
