package run.to.aho.naming.popup.actions;


import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.texteditor.AbstractTextEditor;

import run.to.aho.naming.NamingPlugin;
import run.to.aho.naming.core.DictionaryFile;


public abstract class AbstractNamingAction implements IEditorActionDelegate {
	private ISelection selection;
	private IEditorPart editorPart;

	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		editorPart = targetEditor;
	}

	public AbstractNamingAction() {
		super();
	}
	
	protected abstract String perform(String in, DictionaryFile dic) throws Exception;
	
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
		// TODO ꂽ\bhEX^u
	}

	public void run(IAction action) {
		try {
			ITextSelection textSelection = (ITextSelection)selection;
			IPreferenceStore store = NamingPlugin.getDefault().getPreferenceStore();
			DictionaryFile dic = new DictionaryFile();
			dic.read(store.getString("dictionaryPath"));
			dic.sort();
			String pysicalName = perform(textSelection.getText(), dic);
			AbstractTextEditor editor = (AbstractTextEditor)editorPart;
			IDocument document = editor.getDocumentProvider().getDocument(editor.getEditorInput());
			document.replace(textSelection.getOffset(), textSelection.getLength(), pysicalName);
		} catch (Throwable e) {
			MessageDialog.openError(new Shell(), "G[", e.getMessage());
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;

	}

}
